#!/bin/sh
#event.tcl
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File    : event.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: event.tcl,v 1.1.1.1 2003/11/11 00:33:10 erics Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#  *************************************************************************

proc select {i} {
global listtmp oldi
if {$oldi !=""} {
set listtmp [lreplace $listtmp [expr $oldi*2 + 1] [expr $oldi*2 + 1] [.wevent.frametop.framecenter.text get 0.0 "end - 1c"] ]
}
    for {set k 0} {$k < [expr [llength $listtmp]/2]} {incr k 1} {
    .wevent.frametop.frameleft.l$k configure -background grey
    }
.wevent.frametop.frameleft.l$i configure -background Steelblue2
.wevent.frametop.framecenter.text delete 0.0 end

.wevent.frametop.framecenter.text insert end [string map "returnx \\n" [lindex $listtmp [expr $i*2 + 1]]]
set oldi $i
.wevent.framebottom.framecenter.text delete 1.0 end
.wevent.framebottom.framecenter.text insert end "[mc {Choisir une action :}]\n[mc {L'action affiche permet d'afficher un objet prealablement cache.}]\n\
[mc {L'action cache permet de cacher un objet.}]\n[mc {L'action jouerson permet d'ecouter un son.}]\n[mc {L'action aller gere le changement de page.}]\n\
[mc {L'action jouerson permet d'ecouter un son.}]\n[mc {Les actions curseurmain et curseurnormal permettent de changer la forme du curseur.}]\n\
[mc {L'action deplace permet de deplacer un objet.}]"

}
##############################################################

proc pushEnter {i} {
.wevent.frametop.frameleft.l$i configure -cursor hand2
}

##########################################################
proc pushLeave {i} {
.wevent.frametop.frameleft.l$i configure -cursor left_ptr
}

proc openevent {c} {
toplevel .wevent -background grey

global tabevent tabobj listtmp oldi ind totalpage Home

set oldi ""
set bgn #ffff80
set bgl #ff80c0
set ind [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
if {$ind !="" && $ind != -1} {
set listtmp $tabevent($ind)
#bell
} else {
set listtmp $tabevent(canvas)
}

wm geometry .wevent +0+0

frame .wevent.frametop -background grey -width 600 -height 200
pack .wevent.frametop -side top -pady 5

frame .wevent.frametop.frameleft -background grey -width 100 -height 100
pack .wevent.frametop.frameleft -side left
frame .wevent.frametop.framecenter -background grey
pack .wevent.frametop.framecenter -side left
frame .wevent.frametop.frameright -background grey 
pack .wevent.frametop.frameright -side left -padx 10
frame .wevent.frametop.frameright2 -background grey 
pack .wevent.frametop.frameright2 -side left -padx 10



frame .wevent.framebottom -background grey -width 600 -height 200
pack .wevent.framebottom -side bottom -pady 5
frame .wevent.framebottom.frameleft -background grey -width 100 -height 100
pack .wevent.framebottom.frameleft -side left
frame .wevent.framebottom.framecenter -background grey
pack .wevent.framebottom.framecenter -side left
frame .wevent.framebottom.frameright -background grey
pack .wevent.framebottom.frameright -side left -padx 10
frame .wevent.framebottom.frameright2 -background grey
pack .wevent.framebottom.frameright2 -side left -padx 10


label .wevent.framebottom.frameright.labactions -background grey -text [mc {Actions :}]
pack .wevent.framebottom.frameright.labactions -side top 
listbox .wevent.framebottom.frameright.actions -yscrollcommand ".wevent.framebottom.frameright.scrollactions set" -height 5 -width 10
scrollbar .wevent.framebottom.frameright.scrollactions -command ".wevent.framebottom.frameright.actions yview"
pack .wevent.framebottom.frameright.actions -side left
pack .wevent.framebottom.frameright.scrollactions -side left -fill y
foreach nom {affiche cache jouerson aller {curseur main} {curseur normal} deplace} {
.wevent.framebottom.frameright.actions  insert end $nom
}
bind .wevent.framebottom.frameright.actions <1> "inseretexteactions .wevent.framebottom.frameright.actions %x %y"



label .wevent.framebottom.framecenter.labtext -background grey -text [mc {Aide :}]
pack .wevent.framebottom.framecenter.labtext -side top 

text .wevent.framebottom.framecenter.text -yscrollcommand ".wevent.framebottom.framecenter.scroll set" -setgrid true -width 30 -height 6 -wrap word -background white -font {Arial 10}
scrollbar .wevent.framebottom.framecenter.scroll -command ".wevent.framebottom.framecenter.text yview"
pack .wevent.framebottom.framecenter.scroll -side right -fill y
pack .wevent.framebottom.framecenter.text -side top



label .wevent.frametop.frameright.labobjets -background grey -text [mc {Objets :}]
pack .wevent.frametop.frameright.labobjets -side top 
listbox .wevent.frametop.frameright.objets -yscrollcommand ".wevent.frametop.frameright.scrollobjets set" -height 5 -width 10
scrollbar .wevent.frametop.frameright.scrollobjets -command ".wevent.frametop.frameright.objets yview"
pack .wevent.frametop.frameright.objets -side left
pack .wevent.frametop.frameright.scrollobjets -side left -fill y
foreach nom [array names tabobj] {
.wevent.frametop.frameright.objets  insert end $tabobj($nom)
}
bind .wevent.frametop.frameright.objets  <1> "inseretexte .wevent.frametop.frameright.objets %x %y"


label .wevent.framebottom.frameright2.labpages -background grey -text [mc {Pages :}]
pack .wevent.framebottom.frameright2.labpages -side top 
listbox .wevent.framebottom.frameright2.pages -yscrollcommand ".wevent.framebottom.frameright2.scrollpages set" -height 5 -width 10
scrollbar .wevent.framebottom.frameright2.scrollpages -command ".wevent.framebottom.frameright2.pages yview"
pack .wevent.framebottom.frameright2.pages -side left
pack .wevent.framebottom.frameright2.scrollpages -side left -fill y
for {set x 1} {$x<=$totalpage} {incr x} {
.wevent.framebottom.frameright2.pages  insert end "[mc {Page}] $x"
}
bind .wevent.framebottom.frameright2.pages  <1> "inseretexte .wevent.framebottom.frameright2.pages %x %y"

label .wevent.frametop.frameright2.labsons -background grey -text [mc {Sons :}]
pack .wevent.frametop.frameright2.labsons -side top 
listbox .wevent.frametop.frameright2.sons -yscrollcommand ".wevent.frametop.frameright2.scrollsons set" -height 5 -width 10
scrollbar .wevent.frametop.frameright2.scrollsons -command ".wevent.frametop.frameright2.sons yview"
pack .wevent.frametop.frameright2.sons -side left
pack .wevent.frametop.frameright2.scrollsons -side left -fill y
set ext .wav
foreach i [lsort [glob [file join $Home sons *$ext]]] {
     .wevent.frametop.frameright2.sons insert end [file tail $i]
     }
bind .wevent.frametop.frameright2.sons <1> "inseretexte .wevent.frametop.frameright2.sons %x %y"


button .wevent.framebottom.frameleft.btok -text [mc {   Ok    }] -command "quitevent" -activebackground grey
pack .wevent.framebottom.frameleft.btok -side top -padx 30

label .wevent.frametop.frameleft.labevent -background grey -text [mc {Evenements :}]
pack .wevent.frametop.frameleft.labevent -side top -fill y -expand 1
###########################################################################################""




###########################################################################################"""
set k 0

	for {set i 0} {$i < [llength $listtmp]} {incr i 2} {

    label .wevent.frametop.frameleft.l$k -text [lindex $listtmp $i]  -width 18 -background grey 
    pack .wevent.frametop.frameleft.l$k -side top -fill y -expand 1

    bind .wevent.frametop.frameleft.l$k <Any-Enter> "pushEnter $k"
    bind .wevent.frametop.frameleft.l$k <Any-Leave> "pushLeave $k"
    bind .wevent.frametop.frameleft.l$k <ButtonRelease-1> "select $k"

    incr k
    }


label .wevent.frametop.framecenter.labtext -background grey -text [mc {Script :}]
pack .wevent.frametop.framecenter.labtext -side top 

text .wevent.frametop.framecenter.text -yscrollcommand ".wevent.frametop.framecenter.scroll set" -xscrollcommand ".wevent.frametop.framecenter.scrollh set" -setgrid true -width 30 -height 6 -wrap none -background white -font {Arial 10}
scrollbar .wevent.frametop.framecenter.scroll -command ".wevent.frametop.framecenter.text yview"
scrollbar .wevent.frametop.framecenter.scrollh -orient horiz -command ".wevent.frametop.framecenter.text xview"
pack .wevent.frametop.framecenter.scroll -side right -fill y
pack .wevent.frametop.framecenter.scrollh -side bottom -fill x
pack .wevent.frametop.framecenter.text -side top

if {$ind !="" && $ind != -1} {
wm title .wevent "[mc {Programmation de l'objet}] $tabobj($ind)"
} else {
wm title .wevent "[mc {Programmation de l'objet page}]"
}

select 0
.wevent.framebottom.framecenter.text delete 1.0 end
.wevent.framebottom.framecenter.text insert end "[mc {Choisir un vnement :}]\n[mc {L'evenement enter gere l'entree de la souris sur l'objet.}]\n \
[mc {L'evenement leave gere la sortie de la souris de l'objet.}]\n[mc {L'evenement click gere le click de la souris sur l'objet.}]\n \
[mc {L'evenement pageenter gere la sortie de la page (changement de page) de l'objet page.}]\n[mc {L'evenement pageleave gere l'entree sur la page (changement de page) de l'objet page.}]\n"
}

proc enrtabevent {} {
global tabevent listtmp ind oldi

if {$ind !="" && $ind != -1} {
set tabevent($ind) [string map "\\n returnx" $listtmp]
} else {
set tabevent(canvas) [string map "\\n returnx" $listtmp]

}
}



proc inseretexte {liste x y} {
set cur [.wevent.frametop.framecenter.text index insert]
.wevent.frametop.framecenter.text insert $cur [$liste get @$x,$y]\040
}

proc quitevent {} {
global oldi
if {$oldi != ""} {
select $oldi
}
enrtabevent
sauve .frame.c old
destroy .wevent
}

proc inseretexteactions {liste x y} {
set cur [.wevent.frametop.framecenter.text index insert]
.wevent.frametop.framecenter.text insert $cur [$liste get @$x,$y]\040

.wevent.framebottom.framecenter.text delete 1.0 end 
switch [mc [$liste get @$x,$y]] {
affiche {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {affiche objet .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
cache {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {cache objet .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
jouerson {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {jouerson son .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
aller {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {aller page .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
"curseur main" {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {curseur main .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
"curseur normal" {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {curseur normal .}]\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}
deplace {.wevent.framebottom.framecenter.text insert end "[mc {Syntaxe :}]\n[mc {deplace objet x y repetition delai.}]\n \
[mc {x et y representent les valeurs de deplacement horizontal et vertical.}]\n[mc {repetition le nombre de fois que le deplacement doit etre reitere.}]\n \
[mc {delai le temps de pause entre chaque iteration.}]\n \
\n[mc {Appuyez ensuite sur la touche entree pour changer de ligne.}]"}

}
}
