#!/bin/sh
#kidistb.tcl
#Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : kidistb.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version $Id: kidistb.tcl,v 1.1.1.1 2003/11/11 00:33:10 erics Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################

global tid canvw canvh indexpage totalpage listdata nomf taillefont indexlibre CanvasGere tamponpage Home tabevent basedir

source path.tcl
set plateforme $tcl_platform(platform)
initapp $plateforme
loadlib $plateforme



#wm deiconify .
set nomf ""
set imgid 0
set id 0
set c .frame.c
set bgn #ffff80
set bgl #ff80c0
set font2 ""
set son 1
set tool 0
set totalpage 1
set indexpage 0
set indexlibre 0
set CanvasGere 0
set tamponpage ""
set tabevent(canvas) {pageenter {} pageleave {}}

set listdata {{} {set indexlibre $indexlibre}}
#wm overrideredirect . 1


. configure -background #ffff80
source msg.tcl
source tool.tcl
source event.tcl

#frame .frame -width [expr [winfo screenwidth .] -10] -height [expr [winfo screenheight .] -10] -background gray75
frame .frame -width [expr [winfo screenwidth .]] -height [expr [winfo screenheight .]] -background gray75
pack .frame -side top -fill both -expand yes

wm geometry . +0+0
wm title . [mc {Kidistb - Logiciel de cration multimdia}]



#set canvh [expr [winfo screenheight .] -120]
#set canvw [expr [winfo screenwidth .] - 100]
set canvh [expr [winfo screenheight .] -90]
set canvw [expr [winfo screenwidth .] -70]

canvas $c -width $canvw -height $canvh -background $bgn -highlightbackground #ffff80 -selectbackground green -selectborderwidth 4 
pack $c



frame .bframe -background #ffff80
pack .bframe -side bottom

source son.tcl
source texte.tcl
source enveloppe.tcl
source utils.tcl
source image.tcl
source editeur.tcl
source bouton1.tcl
source polygon.tcl
source bouton2.tcl
source choixpoly.tcl

###################################################################""


#procedures
####################################################""
#procdure principale
#######################################################"

proc cplace {c} {
   global tid canvw canvh taillefont tabobj tabevent indexlibre
      $c delete all

switch [winfo screenwidth .] {
1024 {
set param {500 551 600 481 39 397 488 115 512 485 329 1.75 1.75}
}
800 {
set param {366 472 600 348 27 397 365 110 512 362 295 1.30 1.30}
}
default {
set param {283 336 600 273 31 397 286 102 512 276 231 0.82 0.82}
}
}
createtexte $c [lindex $param 0] [lindex $param 1] {Ouvrez l'exemple conte et appuyez sur le bouton Jouer .} yellow [lindex $param 2] NavyBlue Helvetica 2 black uident1
set tabobj(uident1) uident1
set tabevent(uident1) {enter {} leave {} click {}}
createtexte $c [lindex $param 3] [lindex $param 4] {Kidistoryboard} Yellow [lindex $param 5] NavyBlue Helvetica 6 red4 uident2
set tabobj(uident2) uident2
set tabevent(uident2) {enter {} leave {} click {}}
createtexte $c [lindex $param 6] [lindex $param 7] {Logiciel de cration multimdia pour les enfants.} "" [lindex $param 8] White Helvetica 2 "" uident3
set tabobj(uident3) uident3
set tabevent(uident3) {enter {} leave {} click {}}
#createimage $c {background.gif} [lindex $param 9] [lindex $param 10] [lindex $param 11] [lindex $param 12] uident5
set bimage [getimgid]
image create photo $bimage -file [file join images background.gif]
CZoom $bimage [lindex $param 11] [lindex $param 12]
set id [getid]
$c create image [lindex $param 9] [lindex $param 10] -image $bimage
set tabobj(uident5) uident5
set tabevent(uident5) {enter {} leave {} click {}}
set tabevent(canvas) {pageenter {} pageleave {}}
$c configure -background Blue
set indexlibre 5
 }


###############################################################
#appel de la procdure principale
##############################################################"
cplace $c
focus $c


#############################################################
#gestion des evnements
##########################################################
bind $c <ButtonPress-1> "CanvasStart $c %x %y"
bind $c <B1-Motion> "CanvasDrag $c %x %y"
bind $c <ButtonRelease-1> "CanvasStopDrag $c %x %y"


############################################################################
#gestion du jeu et des dplacements
#############################################################################
##############################################################################
proc CanvasStart {c x y} {

global lastX lastY CanvasGere tid
set CanvasGere 0
set lastX [$c canvasx $x]
set lastY [$c canvasy $y]
$c focus ""
#combien y a-t-il d'objets sous le pointeur au moment du click?
if {[llength [$c find overlapping [expr $x -1] [expr $y -1] [expr $x + 1] [expr $y + 1] ] ] ==0 } {
#if {([lsearch [$c gettags current] drag] ==-1) && ([lsearch [$c gettags current] enveloppe] ==-1) } 
# 0, CanvasGere passe  1, on dtruit l'enveloppe rouge et on prpare l'enveloppe grise de slection multiple
catch {$c dtag all cible}
catch {$c delete enveloppe}
#mise  jour barre des boutons du bas
catch {destroy .waction}
set CanvasGere 1
#ajout du tag CanvasGroup  l'enveloppe grise
$c create rectangle $x $y $x $y -outline gray50 -width 3 -stipple gray50 -tags "CanvasGroup"
} elseif { (([llength [$c find withtag cible]] ==0) || ([llength [$c find withtag cible]] ==1)) && ([lsearch [$c gettags current] enveloppe] ==-1) } {
#autrement, c'est qu'il y a des objets
# s'il n'y a pas d'objet dj slectionn sous le pointeur (cible==0), ou un objet slectionn (cible==1) sans enveloppe autour (enveloppe==-1)
if {[lsearch -regexp [$c gettags current] uident*] !=-1} {
#On le slectionne, avec une enveloppe rouge et on cre la barre d'outils du bas
catch {$c dtag all cible}
catch {$c delete enveloppe}
$c addtag cible withtag current
set typ [lindex [$c gettags current] [lsearch -regexp [$c gettags current] type*]]

creetool $typ $c
$c focus current


createenveloppe $c current
}
}
}


proc CanvasDrag {c x y} {
global lastX lastY CanvasGere tid
#si on est en train de tracer le rectangle de slection
if {$CanvasGere == 1} {
# pour modifier le rectangle de slection gris
$c coords CanvasGroup $lastX $lastY $x $y
# si on n'est pas en train de tracer un rect de slection et qu'on est pas entrain de redimmensionner l'enveloppe (current enveloppe -1)
} elseif {[lsearch [$c gettags current] enveloppe] ==-1} {
$c focus ""
# on dplace tous les objets concernes (groupe ou seul)
foreach tg [$c find withtag cible] {
if {[lsearch -regexp [$c gettags $tg] uident*] !=-1} {
set typ [lindex [$c gettags $tg] [lsearch -regexp [$c gettags $tg] type*]]
switch $typ {


   typetext {
         textmove $c $tg $x $y $lastX $lastY
         }
   typebouton2 {
	bouton2move $c $tg $x $y $lastX $lastY
   	}
   default {
         $c move $tg [expr $x-$lastX] [expr $y-$lastY]}
         }
   }}
$c move enveloppe [expr $x-$lastX] [expr $y-$lastY]
set lastX $x
set lastY $y
}
}


proc CanvasStopDrag {c x y} {
global lastX lastY CanvasGere tid
if {$CanvasGere == 1} {
	# si on construisait le rectangle de slection gris
	set lcordr [$c coords CanvasGroup]
	#overlapping? or enclosed?
	# on tague tous les objets avec cible
	foreach it [$c find overlapping [lindex $lcordr 0] [lindex $lcordr 1] [lindex $lcordr 2] [lindex $lcordr 3] ] {
		if {[lsearch -regexp [$c gettags $it] uident*] !=-1} {
			$c addtag cible withtag $it
			}
	}
#overlapping?
#on rinitialise la barre d'outils si pas d'objet slectionn (<2-> le canvas seul)
	if {[llength [$c find overlapping [lindex $lcordr 0] [lindex $lcordr 1] [lindex $lcordr 2] [lindex $lcordr 3] ]] < 2} {
		creetool canvas $c
		}
#on efface le rectangle gris et on met une enveloppe rouge si besoin
	$c delete CanvasGroup
	if {[llength [$c find withtag cible]] !=0} {
		createenveloppe $c cible
		}
} else {
# si on n'tait pas en train de tracer le rectangle de slection multiple
#On met le focus sur le texte si le widget en dispose
	set CanvasGere 0
	if {[llength [$c find withtag cible]] ==1} {
		set typ [lindex [$c gettags current] [lsearch -regexp [$c gettags current] type*]]
		switch $typ {
			typebouton2 {
			$c focus [lindex $tid([lindex [$c gettags current] [lsearch -regexp [$c gettags current] uident*]]) 4]
			focus $c
			}
			typetext {$c focus current}
		}
	}
}

}




