$c bind typetext <1> "textB1Press $c %x %y"
$c bind typetext <3> "$c select from current insert"
$c bind typetext <B3-Motion> "$c select adjust current @%x,%y"

$c bind typetext <KeyPress> "keyc $c %A"
$c bind typetext <Return> "keyc $c \\n"
$c bind typetext <Control-h> "textBs $c"
$c bind typetext <BackSpace> "textBs $c"
$c bind typetext <Delete> "textDel $c"
$c bind typetext <Control-c> "Textcopy $c"
$c bind typetext <Control-v> "Textpaste $c"
$c bind typetext <Key-Right> {TextMoveRight $c}
$c bind typetext <Key-Left> {TextMoveLeft $c}


proc textB1Press {w x y} {

    $w select clear
    $w icursor cible @$x,$y
    $w focus cible
    focus $w
}

proc TextMoveLeft {c} {
set foc [$c focus]
catch {
$c icursor $foc [expr [$c index $foc insert] - 1]
}
}

proc TextMoveRight {c} {
set foc [$c focus]
catch {
$c icursor $foc [expr [$c index $foc insert] + 1]
}
}

proc Textcopy {c} {
clipboard clear
catch {
set t [$c select item]
set text [$c itemcget $t -text]
set start [$c index $t sel.first]
set end [$c index $t sel.last]
clipboard append [string range $text $start $end]
}
}

proc Textpaste {c} {
#catch [set selec [selection get]]
catch {
set selec [selection get -selection CLIPBOARD]
textInsert $c $selec
}
}

proc keyc {c A} {
textInsert $c $A
redessineenveloppe $c cible
}

proc textInsert {w string} {
    if {$string == ""} {
	return
    }
    catch {$w dchars text sel.first sel.last}
    $w insert cible insert $string
    redessineenveloppe $w cible
    redessinetexte $w

}



proc textBs {w} {
    if ![catch {$w dchars cible sel.first sel.last}] {
	redessineenveloppe $w cible
      redessinetexte $w
	return
    }
    set char [expr {[$w index cible insert] - 1}]
    if {$char >= 0} {

      $w dchar cible $char
if {[$w itemcget cible -text] ==""} {
$w insert cible insert " "
}

      redessineenveloppe $w cible
      redessinetexte $w
      }
}

proc textDel {w} {
    if ![catch {$w dchars cible sel.first sel.last}] {
      redessineenveloppe $w cible
      redessinetexte $w
	return
    }
    $w dchars cible insert
if {[$w itemcget cible -text] ==""} {
$w insert cible insert " "
}
      redessineenveloppe $w cible
      redessinetexte $w
}

proc textmove {c tg x y lastX lastY} {
         global tid
         $c move $tg [expr $x-$lastX] [expr $y-$lastY]
         set id [lindex [$c gettags $tg] [lsearch -regexp [$c gettags $tg] uident*]]
         $c move [lindex $tid($id) 0] [expr $x-$lastX] [expr $y-$lastY]

}


proc redessinetexte {w} {
    global tid
    set id [lindex [$w gettags cible] [lsearch -regexp [$w gettags cible] uident*]]
    $w coords [lindex $tid($id) 0] [$w bbox cible]
}

proc createtexte {c x y texte couleur largeur fillcouleur police taillepol trait identif} {
   global tid tabson taillefont tabobj tabevent
if {$identif =="new"} {
   set id [getid]
} else {
set id $identif
}
$c dtag cible
$c focus ""
creetool canvas $c
catch {$c delete enveloppe}
   set idtmp2 [$c create rect 0 0 0 0 -fill $couleur -state normal -outline $trait]
   set idtmp1 [$c create text $x $y -text [join $texte] -width $largeur -anchor n -font "$police [lindex $taillefont $taillepol]" -justify left -fill $fillcouleur -tags "drag $id typetext" ]
   $c coords $idtmp2 [$c bbox $idtmp1]
   $c lower $idtmp2 $idtmp1

set tid($id) "$idtmp2 $taillepol $id"
set tabobj($id) $id 
set tabevent($id) {enter {} leave {} click {}}  
set tabson($id) ""

 #$c icursor cible @$x,$y
  #  $c focus cible
  #  focus $c
#createenveloppe $c cible
}

proc retailletexte {c lcord id} {
   global tid
   $c itemconfigure cible -width [expr [lindex $lcord 2] - [lindex $lcord 0] ]
   $c coords [lindex $tid($id) 0] [$c bbox cible]
   redessineenveloppe $c cible

}


proc changepolice {c police} {
set ppolice [$c itemcget cible -font]
set ppolice [lreplace $ppolice 0 0 $police]
$c itemconfigure cible -font $ppolice
redessinetexte $c
redessineenveloppe $c cible

}

proc changetaille {c taille} {
global taillefont tid
set ppolice [$c itemcget cible -font]
set ppolice [lreplace $ppolice 1 1 [lindex $taillefont $taille]]
$c itemconfigure cible -font $ppolice
redessinetexte $c
redessineenveloppe $c cible
set id [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
set tmp [lindex $tid($id) 0]
set tid($id) "$tmp $taille $id"

}

proc fondtrans {c ftrans} {
global tid
if {$ftrans ==0} {
set id [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
$c itemconfigure [expr [lindex $tid($id) 0]] -outline "" -fill ""
}
}

proc changefond {c coul} {
global tid
variable ftrans
set ftrans 0
set id [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
$c itemconfigure [expr [lindex $tid($id) 0]] -fill $coul
}


proc changetrait {c coul} {
global tid
variable ftrans
set ftrans 0
set id [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
$c itemconfigure [expr [lindex $tid($id) 0]] -outline $coul
}


proc opentext {c} {
global canvw canvh taillefont
createtexte $c [expr int($canvw/2)] [expr int($canvh/2)] [mc {Texte}] "" 100 black Helvetica 3 black new
#creetool text $c
}
